diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/wifi-mac-ofdma-test.cc ns-3.38/src/wifi/test/wifi-mac-ofdma-test.cc
--- ns-3.37/src/wifi/test/wifi-mac-ofdma-test.cc	2022-11-01 17:37:24.763395800 -0700
+++ ns-3.38/src/wifi/test/wifi-mac-ofdma-test.cc	2023-03-16 20:54:23.872869300 -0700
@@ -740,24 +940,30 @@
         uint8_t tid = staId * 2;
         NS_TEST_EXPECT_MSG_EQ(+hdr.GetQosTid(), +tid, "Expected a TID equal to " << +tid);
     }
-    tStart = m_txPsdus[3].startTx;
+    tStart = m_txPsdus[8].startTx;
     NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "QoS Null frame in HE TB PPDU sent too early");
     NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "QoS Null frame in HE TB PPDU sent too late");
-    NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                m_txPsdus[3].endTx,
-                                "Duration/ID in BSRP Trigger Frame is too short");
-
-    // A fourth STA sends a QoS Null frame in an HE TB PPDU a SIFS after the reception of the BSRP
-    // TF
-    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[4].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                           m_txPsdus[4].psduMap.size() == 1 &&
-                           m_txPsdus[4].psduMap.begin()->second->GetNMpdus() == 1),
+    qosNullNavEnd = m_txPsdus[8].endTx + m_txPsdus[8].psduMap.begin()->second->GetDuration();
+    if (m_txopLimit == 0)
+    {
+        NS_TEST_EXPECT_MSG_EQ(qosNullNavEnd,
+                              m_txPsdus[8].endTx,
+                              "Expected null Duration/ID for QoS Null frame in HE TB PPDU");
+    }
+    // navEnd <= qosNullNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, qosNullNavEnd, "Duration/ID in QoS Null is too short");
+    NS_TEST_EXPECT_MSG_LT(qosNullNavEnd, navEnd + tolerance, "Duration/ID in QoS Null is too long");
+
+    // A fourth STA sends a QoS Null frame in a TB PPDU a SIFS after the reception of the BSRP TF
+    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[9].txVector.GetPreambleType() == m_tbPreamble &&
+                           m_txPsdus[9].psduMap.size() == 1 &&
+                           m_txPsdus[9].psduMap.begin()->second->GetNMpdus() == 1),
                           true,
                           "Expected a QoS Null frame in an HE TB PPDU");
     {
-        const WifiMacHeader& hdr = m_txPsdus[4].psduMap.begin()->second->GetHeader(0);
+        const WifiMacHeader& hdr = m_txPsdus[9].psduMap.begin()->second->GetHeader(0);
         NS_TEST_EXPECT_MSG_EQ(hdr.GetType(), WIFI_MAC_QOSDATA_NULL, "Expected a QoS Null frame");
         uint16_t staId;
         for (staId = 0; staId < m_nStations; staId++)
@@ -771,104 +977,241 @@
         uint8_t tid = staId * 2;
         NS_TEST_EXPECT_MSG_EQ(+hdr.GetQosTid(), +tid, "Expected a TID equal to " << +tid);
     }
-    tStart = m_txPsdus[4].startTx;
+    tStart = m_txPsdus[9].startTx;
     NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "QoS Null frame in HE TB PPDU sent too early");
     NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "QoS Null frame in HE TB PPDU sent too late");
-    NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                m_txPsdus[4].endTx,
-                                "Duration/ID in BSRP Trigger Frame is too short");
+    qosNullNavEnd = m_txPsdus[9].endTx + m_txPsdus[9].psduMap.begin()->second->GetDuration();
+    if (m_txopLimit == 0)
+    {
+        NS_TEST_EXPECT_MSG_EQ(qosNullNavEnd,
+                              m_txPsdus[9].endTx,
+                              "Expected null Duration/ID for QoS Null frame in HE TB PPDU");
+    }
+    // navEnd <= qosNullNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, qosNullNavEnd, "Duration/ID in QoS Null is too short");
+    NS_TEST_EXPECT_MSG_LT(qosNullNavEnd, navEnd + tolerance, "Duration/ID in QoS Null is too long");
 
-    // the AP sends a Basic Trigger Frame to solicit QoS data frames
-    NS_TEST_EXPECT_MSG_GT_OR_EQ(m_txPsdus.size(), 11, "Expected at least 11 transmitted packets");
-    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[5].psduMap.size() == 1 &&
-                           m_txPsdus[5].psduMap[SU_STA_ID]->GetHeader(0).IsTrigger() &&
-                           m_txPsdus[5].psduMap[SU_STA_ID]->GetHeader(0).GetAddr1().IsBroadcast()),
+    // the AP sends another MU-RTS Trigger Frame to protect the Basic TF
+    NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(), 15, "Expected at least 15 transmitted packet");
+    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[10].psduMap.size() == 1 &&
+                           m_txPsdus[10].psduMap[SU_STA_ID]->GetHeader(0).IsTrigger() &&
+                           m_txPsdus[10].psduMap[SU_STA_ID]->GetHeader(0).GetAddr1().IsBroadcast()),
                           true,
                           "Expected a Trigger Frame");
-    m_txPsdus[5].psduMap[SU_STA_ID]->GetPayload(0)->PeekHeader(trigger);
-    NS_TEST_EXPECT_MSG_EQ(trigger.IsBasic(), true, "Expected a Basic Trigger Frame");
+    m_txPsdus[10].psduMap[SU_STA_ID]->GetPayload(0)->PeekHeader(trigger);
+    NS_TEST_EXPECT_MSG_EQ(trigger.IsMuRts(), true, "Expected an MU-RTS Trigger Frame");
     NS_TEST_EXPECT_MSG_EQ(trigger.GetNUserInfoFields(),
                           4,
                           "Expected one User Info field per station");
-    tEnd = m_txPsdus[1].endTx;
-    tStart = m_txPsdus[5].startTx;
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[10].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the MU-RTS to occupy the entire channel width");
+    for (const auto& userInfo : trigger)
+    {
+        NS_TEST_EXPECT_MSG_EQ(+userInfo.GetMuRtsRuAllocation(),
+                              +m_muRtsRuAllocation,
+                              "Unexpected RU Allocation value in MU-RTS");
+    }
+    tEnd = m_txPsdus[9].endTx;
+    tStart = m_txPsdus[10].startTx;
     NS_TEST_EXPECT_MSG_LT(tEnd + ifs, tStart, "Basic Trigger Frame sent too early");
     if (m_txopLimit > 0)
     {
         NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Basic Trigger Frame sent too late");
+        // Duration/ID still protects until the end of the TXOP
+        auto muRtsNavEnd = m_txPsdus[10].endTx + m_txPsdus[10].psduMap[SU_STA_ID]->GetDuration();
+        // navEnd <= muRtsNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, muRtsNavEnd, "Duration/ID in MU-RTS is too short");
+        NS_TEST_EXPECT_MSG_LT(muRtsNavEnd, navEnd + tolerance, "Duration/ID in MU-RTS is too long");
     }
 
-    // A first STA sends QoS data frames in an HE TB PPDU a SIFS after the reception of the Basic TF
-    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[6].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                           m_txPsdus[6].psduMap.size() == 1 &&
-                           m_txPsdus[6].psduMap.begin()->second->GetNMpdus() == 2 &&
-                           m_txPsdus[6].psduMap.begin()->second->GetHeader(0).IsQosData() &&
-                           m_txPsdus[6].psduMap.begin()->second->GetHeader(1).IsQosData()),
+    // NAV end is now set by the Duration/ID of the second MU-RTS TF
+    tEnd = m_txPsdus[10].endTx;
+    navEnd = tEnd + m_txPsdus[10].psduMap[SU_STA_ID]->GetDuration();
+
+    // A first STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_txPsdus[11].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+         m_txPsdus[11].psduMap.size() == 1 &&
+         m_txPsdus[11].psduMap.begin()->second->GetNMpdus() == 1 &&
+         m_txPsdus[11].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+        true,
+        "Expected a CTS frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[11].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the CTS to occupy the entire channel width");
+
+    tStart = m_txPsdus[11].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+    ctsNavEnd = m_txPsdus[11].endTx + m_txPsdus[11].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= ctsNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+
+    // A second STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_txPsdus[12].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+         m_txPsdus[12].psduMap.size() == 1 &&
+         m_txPsdus[12].psduMap.begin()->second->GetNMpdus() == 1 &&
+         m_txPsdus[12].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+        true,
+        "Expected a CTS frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[12].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the CTS to occupy the entire channel width");
+
+    tStart = m_txPsdus[12].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+    ctsNavEnd = m_txPsdus[12].endTx + m_txPsdus[12].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= ctsNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+
+    // A third STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_txPsdus[13].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+         m_txPsdus[13].psduMap.size() == 1 &&
+         m_txPsdus[13].psduMap.begin()->second->GetNMpdus() == 1 &&
+         m_txPsdus[13].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+        true,
+        "Expected a CTS frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[13].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the CTS to occupy the entire channel width");
+
+    tStart = m_txPsdus[13].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+    ctsNavEnd = m_txPsdus[13].endTx + m_txPsdus[13].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= ctsNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+
+    // A fourth STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_txPsdus[14].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+         m_txPsdus[14].psduMap.size() == 1 &&
+         m_txPsdus[14].psduMap.begin()->second->GetNMpdus() == 1 &&
+         m_txPsdus[14].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+        true,
+        "Expected a CTS frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[14].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the CTS to occupy the entire channel width");
+
+    tStart = m_txPsdus[14].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+    ctsNavEnd = m_txPsdus[14].endTx + m_txPsdus[14].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= ctsNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+
+    // the AP sends a Basic Trigger Frame to solicit QoS data frames
+    NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(), 21, "Expected at least 21 transmitted packets");
+    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[15].psduMap.size() == 1 &&
+                           m_txPsdus[15].psduMap[SU_STA_ID]->GetHeader(0).IsTrigger() &&
+                           m_txPsdus[15].psduMap[SU_STA_ID]->GetHeader(0).GetAddr1().IsBroadcast()),
+                          true,
+                          "Expected a Trigger Frame");
+    m_txPsdus[15].psduMap[SU_STA_ID]->GetPayload(0)->PeekHeader(trigger);
+    NS_TEST_EXPECT_MSG_EQ(trigger.IsBasic(), true, "Expected a Basic Trigger Frame");
+    NS_TEST_EXPECT_MSG_EQ(trigger.GetNUserInfoFields(),
+                          4,
+                          "Expected one User Info field per station");
+    tEnd = m_txPsdus[14].endTx;
+    tStart = m_txPsdus[15].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Basic Trigger Frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Basic Trigger Frame sent too late");
+    Time basicNavEnd = m_txPsdus[15].endTx + m_txPsdus[15].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= basicNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, basicNavEnd, "Duration/ID in Basic TF is too short");
+    NS_TEST_EXPECT_MSG_LT(basicNavEnd, navEnd + tolerance, "Duration/ID in Basic TF is too long");
+
+    // A first STA sends QoS data frames in a TB PPDU a SIFS after the reception of the Basic TF
+    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[16].txVector.GetPreambleType() == m_tbPreamble &&
+                           m_txPsdus[16].psduMap.size() == 1 &&
+                           m_txPsdus[16].psduMap.begin()->second->GetNMpdus() == 2 &&
+                           m_txPsdus[16].psduMap.begin()->second->GetHeader(0).IsQosData() &&
+                           m_txPsdus[16].psduMap.begin()->second->GetHeader(1).IsQosData()),
                           true,
                           "Expected 2 QoS data frames in an HE TB PPDU");
-    tEnd = m_txPsdus[5].endTx;
-    tStart = m_txPsdus[6].startTx;
+    tEnd = m_txPsdus[15].endTx;
+    tStart = m_txPsdus[16].startTx;
     NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "QoS data frames in HE TB PPDU sent too early");
     NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "QoS data frames in HE TB PPDU sent too late");
-
-    // A second STA sends QoS data frames in an HE TB PPDU a SIFS after the reception of the Basic
-    // TF
-    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[7].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                           m_txPsdus[7].psduMap.size() == 1 &&
-                           m_txPsdus[7].psduMap.begin()->second->GetNMpdus() == 2 &&
-                           m_txPsdus[7].psduMap.begin()->second->GetHeader(0).IsQosData() &&
-                           m_txPsdus[7].psduMap.begin()->second->GetHeader(1).IsQosData()),
+    Time qosDataNavEnd = m_txPsdus[16].endTx + m_txPsdus[16].psduMap.begin()->second->GetDuration();
+    // navEnd <= qosDataNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, qosDataNavEnd, "Duration/ID in QoS Data is too short");
+    NS_TEST_EXPECT_MSG_LT(qosDataNavEnd, navEnd + tolerance, "Duration/ID in QoS Data is too long");
+
+    // A second STA sends QoS data frames in a TB PPDU a SIFS after the reception of the Basic TF
+    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[17].txVector.GetPreambleType() == m_tbPreamble &&
+                           m_txPsdus[17].psduMap.size() == 1 &&
+                           m_txPsdus[17].psduMap.begin()->second->GetNMpdus() == 2 &&
+                           m_txPsdus[17].psduMap.begin()->second->GetHeader(0).IsQosData() &&
+                           m_txPsdus[17].psduMap.begin()->second->GetHeader(1).IsQosData()),
                           true,
                           "Expected 2 QoS data frames in an HE TB PPDU");
-    tEnd = m_txPsdus[5].endTx;
-    tStart = m_txPsdus[7].startTx;
+    tStart = m_txPsdus[17].startTx;
     NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "QoS data frames in HE TB PPDU sent too early");
     NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "QoS data frames in HE TB PPDU sent too late");
-
-    // A third STA sends QoS data frames in an HE TB PPDU a SIFS after the reception of the Basic TF
-    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[8].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                           m_txPsdus[8].psduMap.size() == 1 &&
-                           m_txPsdus[8].psduMap.begin()->second->GetNMpdus() == 2 &&
-                           m_txPsdus[8].psduMap.begin()->second->GetHeader(0).IsQosData() &&
-                           m_txPsdus[8].psduMap.begin()->second->GetHeader(1).IsQosData()),
+    qosDataNavEnd = m_txPsdus[17].endTx + m_txPsdus[17].psduMap.begin()->second->GetDuration();
+    // navEnd <= qosDataNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, qosDataNavEnd, "Duration/ID in QoS Data is too short");
+    NS_TEST_EXPECT_MSG_LT(qosDataNavEnd, navEnd + tolerance, "Duration/ID in QoS Data is too long");
+
+    // A third STA sends QoS data frames in a TB PPDU a SIFS after the reception of the Basic TF
+    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[18].txVector.GetPreambleType() == m_tbPreamble &&
+                           m_txPsdus[18].psduMap.size() == 1 &&
+                           m_txPsdus[18].psduMap.begin()->second->GetNMpdus() == 2 &&
+                           m_txPsdus[18].psduMap.begin()->second->GetHeader(0).IsQosData() &&
+                           m_txPsdus[18].psduMap.begin()->second->GetHeader(1).IsQosData()),
                           true,
                           "Expected 2 QoS data frames in an HE TB PPDU");
-    tEnd = m_txPsdus[5].endTx;
-    tStart = m_txPsdus[8].startTx;
+    tStart = m_txPsdus[18].startTx;
     NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "QoS data frames in HE TB PPDU sent too early");
     NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "QoS data frames in HE TB PPDU sent too late");
-
-    // A fourth STA sends QoS data frames in an HE TB PPDU a SIFS after the reception of the Basic
-    // TF
-    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[9].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                           m_txPsdus[9].psduMap.size() == 1 &&
-                           m_txPsdus[9].psduMap.begin()->second->GetNMpdus() == 2 &&
-                           m_txPsdus[9].psduMap.begin()->second->GetHeader(0).IsQosData() &&
-                           m_txPsdus[9].psduMap.begin()->second->GetHeader(1).IsQosData()),
+    qosDataNavEnd = m_txPsdus[18].endTx + m_txPsdus[18].psduMap.begin()->second->GetDuration();
+    // navEnd <= qosDataNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, qosDataNavEnd, "Duration/ID in QoS Data is too short");
+    NS_TEST_EXPECT_MSG_LT(qosDataNavEnd, navEnd + tolerance, "Duration/ID in QoS Data is too long");
+
+    // A fourth STA sends QoS data frames in a TB PPDU a SIFS after the reception of the Basic TF
+    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[19].txVector.GetPreambleType() == m_tbPreamble &&
+                           m_txPsdus[19].psduMap.size() == 1 &&
+                           m_txPsdus[19].psduMap.begin()->second->GetNMpdus() == 2 &&
+                           m_txPsdus[19].psduMap.begin()->second->GetHeader(0).IsQosData() &&
+                           m_txPsdus[19].psduMap.begin()->second->GetHeader(1).IsQosData()),
                           true,
                           "Expected 2 QoS data frames in an HE TB PPDU");
-    tEnd = m_txPsdus[5].endTx;
-    tStart = m_txPsdus[9].startTx;
+    tStart = m_txPsdus[19].startTx;
     NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "QoS data frames in HE TB PPDU sent too early");
     NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "QoS data frames in HE TB PPDU sent too late");
+    qosDataNavEnd = m_txPsdus[19].endTx + m_txPsdus[19].psduMap.begin()->second->GetDuration();
+    // navEnd <= qosDataNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, qosDataNavEnd, "Duration/ID in QoS Data is too short");
+    NS_TEST_EXPECT_MSG_LT(qosDataNavEnd, navEnd + tolerance, "Duration/ID in QoS Data is too long");
 
     // the AP sends a Multi-STA Block Ack
-    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[10].psduMap.size() == 1 &&
-                           m_txPsdus[10].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAck() &&
-                           m_txPsdus[10].psduMap[SU_STA_ID]->GetHeader(0).GetAddr1().IsBroadcast()),
+    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[20].psduMap.size() == 1 &&
+                           m_txPsdus[20].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAck() &&
+                           m_txPsdus[20].psduMap[SU_STA_ID]->GetHeader(0).GetAddr1().IsBroadcast()),
                           true,
                           "Expected a Block Ack");
-    m_txPsdus[10].psduMap[SU_STA_ID]->GetPayload(0)->PeekHeader(blockAck);
+    m_txPsdus[20].psduMap[SU_STA_ID]->GetPayload(0)->PeekHeader(blockAck);
     NS_TEST_EXPECT_MSG_EQ(blockAck.IsMultiSta(), true, "Expected a Multi-STA Block Ack");
     NS_TEST_EXPECT_MSG_EQ(blockAck.GetNPerAidTidInfoSubfields(),
                           4,
